<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProductPeriod ArrayType
 * @subpackage Arrays
 */
class ArrayOfProductPeriod extends AbstractStructArrayBase
{
    /**
     * The productPeriod
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ProductPeriod[]
     */
    public $productPeriod;
    /**
     * Constructor method for ArrayOfProductPeriod
     * @uses ArrayOfProductPeriod::setProductPeriod()
     * @param \StructType\ProductPeriod[] $productPeriod
     */
    public function __construct(array $productPeriod = array())
    {
        $this
            ->setProductPeriod($productPeriod);
    }
    /**
     * Get productPeriod value
     * @return \StructType\ProductPeriod[]|null
     */
    public function getProductPeriod()
    {
        return $this->productPeriod;
    }
    /**
     * This method is responsible for validating the values passed to the setProductPeriod method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProductPeriod method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProductPeriodForArrayConstraintsFromSetProductPeriod(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfProductPeriodProductPeriodItem) {
            // validation for constraint: itemType
            if (!$arrayOfProductPeriodProductPeriodItem instanceof \StructType\ProductPeriod) {
                $invalidValues[] = is_object($arrayOfProductPeriodProductPeriodItem) ? get_class($arrayOfProductPeriodProductPeriodItem) : sprintf('%s(%s)', gettype($arrayOfProductPeriodProductPeriodItem), var_export($arrayOfProductPeriodProductPeriodItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The productPeriod property can only contain items of type \StructType\ProductPeriod, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set productPeriod value
     * @throws \InvalidArgumentException
     * @param \StructType\ProductPeriod[] $productPeriod
     * @return \ArrayType\ArrayOfProductPeriod
     */
    public function setProductPeriod(array $productPeriod = array())
    {
        // validation for constraint: array
        if ('' !== ($productPeriodArrayErrorMessage = self::validateProductPeriodForArrayConstraintsFromSetProductPeriod($productPeriod))) {
            throw new \InvalidArgumentException($productPeriodArrayErrorMessage, __LINE__);
        }
        $this->productPeriod = $productPeriod;
        return $this;
    }
    /**
     * Add item to productPeriod value
     * @throws \InvalidArgumentException
     * @param \StructType\ProductPeriod $item
     * @return \ArrayType\ArrayOfProductPeriod
     */
    public function addToProductPeriod(\StructType\ProductPeriod $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProductPeriod) {
            throw new \InvalidArgumentException(sprintf('The productPeriod property can only contain items of type \StructType\ProductPeriod, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->productPeriod[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProductPeriod|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProductPeriod|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProductPeriod|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProductPeriod|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProductPeriod|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string productPeriod
     */
    public function getAttributeName()
    {
        return 'productPeriod';
    }
}
