<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSocialEstablishmentNetwork ArrayType
 * @subpackage Arrays
 */
class ArrayOfSocialEstablishmentNetwork extends AbstractStructArrayBase
{
    /**
     * The SocialEstablishmentNetwork
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SocialEstablishmentNetwork[]
     */
    public $SocialEstablishmentNetwork;
    /**
     * Constructor method for ArrayOfSocialEstablishmentNetwork
     * @uses ArrayOfSocialEstablishmentNetwork::setSocialEstablishmentNetwork()
     * @param \StructType\SocialEstablishmentNetwork[] $socialEstablishmentNetwork
     */
    public function __construct(array $socialEstablishmentNetwork = array())
    {
        $this
            ->setSocialEstablishmentNetwork($socialEstablishmentNetwork);
    }
    /**
     * Get SocialEstablishmentNetwork value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SocialEstablishmentNetwork[]|null
     */
    public function getSocialEstablishmentNetwork()
    {
        return isset($this->SocialEstablishmentNetwork) ? $this->SocialEstablishmentNetwork : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSocialEstablishmentNetwork method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSocialEstablishmentNetwork method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSocialEstablishmentNetworkForArrayConstraintsFromSetSocialEstablishmentNetwork(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSocialEstablishmentNetworkSocialEstablishmentNetworkItem) {
            // validation for constraint: itemType
            if (!$arrayOfSocialEstablishmentNetworkSocialEstablishmentNetworkItem instanceof \StructType\SocialEstablishmentNetwork) {
                $invalidValues[] = is_object($arrayOfSocialEstablishmentNetworkSocialEstablishmentNetworkItem) ? get_class($arrayOfSocialEstablishmentNetworkSocialEstablishmentNetworkItem) : sprintf('%s(%s)', gettype($arrayOfSocialEstablishmentNetworkSocialEstablishmentNetworkItem), var_export($arrayOfSocialEstablishmentNetworkSocialEstablishmentNetworkItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SocialEstablishmentNetwork property can only contain items of type \StructType\SocialEstablishmentNetwork, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SocialEstablishmentNetwork value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SocialEstablishmentNetwork[] $socialEstablishmentNetwork
     * @return \ArrayType\ArrayOfSocialEstablishmentNetwork
     */
    public function setSocialEstablishmentNetwork(array $socialEstablishmentNetwork = array())
    {
        // validation for constraint: array
        if ('' !== ($socialEstablishmentNetworkArrayErrorMessage = self::validateSocialEstablishmentNetworkForArrayConstraintsFromSetSocialEstablishmentNetwork($socialEstablishmentNetwork))) {
            throw new \InvalidArgumentException($socialEstablishmentNetworkArrayErrorMessage, __LINE__);
        }
        if (is_null($socialEstablishmentNetwork) || (is_array($socialEstablishmentNetwork) && empty($socialEstablishmentNetwork))) {
            unset($this->SocialEstablishmentNetwork);
        } else {
            $this->SocialEstablishmentNetwork = $socialEstablishmentNetwork;
        }
        return $this;
    }
    /**
     * Add item to SocialEstablishmentNetwork value
     * @throws \InvalidArgumentException
     * @param \StructType\SocialEstablishmentNetwork $item
     * @return \ArrayType\ArrayOfSocialEstablishmentNetwork
     */
    public function addToSocialEstablishmentNetwork(\StructType\SocialEstablishmentNetwork $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SocialEstablishmentNetwork) {
            throw new \InvalidArgumentException(sprintf('The SocialEstablishmentNetwork property can only contain items of type \StructType\SocialEstablishmentNetwork, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SocialEstablishmentNetwork[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SocialEstablishmentNetwork|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SocialEstablishmentNetwork|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SocialEstablishmentNetwork|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SocialEstablishmentNetwork|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SocialEstablishmentNetwork|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SocialEstablishmentNetwork
     */
    public function getAttributeName()
    {
        return 'SocialEstablishmentNetwork';
    }
}
